#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll INF = 1e17;

vector<vector<ll> > sparse_table;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector<ll> arr(n);
    int Test4 = 0;
    ll cnt = 0, val = INF;
    ll id = 0;
    for (ll &i: arr) {
        cin >> i;
        if (val > i)
            val = id;
        val = min(val, i);
    }
    ll tu = 0;
    for (int i = id + 1; i < n - 1; ++i) {
        if (arr[i] > arr[i + 1]) {
            tu = 1;
            break;
        }
    }
    if (tu == 0) {
        vector<ll> up(n);
        vector<ll> water(n, 0);
        vector<ll> mx(n);
        for (int i = 0; i < n; ++i) {
            up[i] = i + 1;
            mx[i] = -INF;
        }
        for (int i = 0; i < n - 1; ++i) {
            ll t;
            cin >> t;
            t--;
            ll nex = up[up[t]] - 1;
            ll n1 = water[t], n2 = water[up[t]];
            ll s = n1 + n2;
            if (t < id && nex > id) {
                s += min(arr[t], arr[nex]) - mx[t];
            }
            mx[t] = max(mx[t], max(arr[t], arr[nex]));
            up[t] = nex + 1;
            water[t] = s;
            cout << s << '\n';
        }
        exit(0);
    }
    sparse_table.assign(log2(n), vector<ll>(n));
    vector<vector<ll> > dp(n, vector<ll>(n));
    vector<vector<ll> > m(n, vector<ll>(n));
    vector<vector<ll> > idx(n, vector<ll>(n));
    for (int i = 0; i < n; ++i) {
        dp[i][i] = 0;
        m[i][i] = -INF;
        if (i != n - 1) {
            dp[i][i + 1] = 0, m[i][i + 1] = arr[i + 1], idx[i][i + 1] = i + 1;
        }
    }
    for (int len = 3; len <= n; ++len) {
        for (int l = 0; l <= n - len; ++l) {
            int r = l + len - 1;
            ll c = idx[l][r - 1];
            ll a = arr[l], b = arr[r], mid = arr[c];
            dp[l][r] = dp[l][c] + dp[c][r];
            if (a >= mid && b >= mid) {
                ll p = min(a, b);
                dp[l][r] += (len - 2) * (p - mid);
            }
            idx[l][r] = c;
            m[l][r] = m[l][r - 1];
            if (m[l][r] < b) {
                m[l][r] = b, idx[l][r] = r;
            }
        }
    }
    vector<ll> sz(n, 1);
    vector<ll> num(n);
    for (int i = 0; i < n; ++i) {
        num[i] = i;
    }
    for (int i = 0; i < n - 1; ++i) {
        ll t;
        cin >> t;
        t--;
        ll len = sz[t];
        ll l = sz[t + 1];
        cout << dp[num[t]][num[t] + len + l - 1] << '\n';
        sz[t] += l;
        for (int j = t + 1; j < (ll) sz.size() - 1; ++j) {
            sz[j] = sz[j + 1];
            num[j] = num[j + 1];
        }
        sz.pop_back();
        num.pop_back();
    }
}
