#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll INF = 1e17;

vector<vector<ll> > sparse_table;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector<ll> arr(n);
    int Test4 = 0;
    ll cnt = 0, val = INF;
    ll id = 0;
    for (int i = 0; i < n; ++i) {
        ll elem;
        cin >> elem;
        arr[i] = elem;
        if (val > elem)
            id = i, val = elem;
    }
    ll tu = 0;
    for (int i = id + 1; i < n - 1; ++i) {
        if (arr[i] > arr[i + 1]) {
            tu = 1;
            break;
        }
    }
    if (tu == 0) {
        vector<ll> up(n);
        vector<ll> sum (n);
        sum[0] = arr[0];
        for (int i = 0; i < n; ++i) {
            up[i] = i+1;
        }
        for (int i = 1; i < n; ++i)
            sum[i] = sum[i - 1] + arr[i];
        for (int i = 0; i < n - 1; ++i) {
            ll t;
            cin >> t;
            t--;
            ll nex = up[up[t]] - 1;
            ll s = 0;
            if (t < id && nex > id) {
                ll h = min(arr[t], arr[nex]);
                ll l = id, r = nex;
                while (l + 1 < r) {
                    ll m = (l+r)/2;
                    if (arr[m] >= h)
                        r = m;
                    else
                        l = m;
                }
                ll l0 = t, r0 = id;
                while (l0 + 1 < r0) {
                    ll m = (l0+r0)/2;
                    if (arr[m] >= h)
                        l0 = m;
                    else
                        r0 = m;
                }
                s = h*(l-r0+1);
                s -= sum[l];
                if (r0-1 >= 0)
                    s += sum[r0-1];
            }
            up[t] = nex + 1;
            cout << s << '\n';
        }
        exit(0);
    }
    sparse_table.assign(log2(n), vector<ll>(n));
    vector<vector<ll> > dp(n, vector<ll>(n));
    vector<vector<ll> > m(n, vector<ll>(n));
    vector<vector<ll> > idx(n, vector<ll>(n));
    for (int i = 0; i < n; ++i) {
        dp[i][i] = 0;
        m[i][i] = -INF;
        if (i != n - 1) {
            dp[i][i + 1] = 0, m[i][i + 1] = arr[i + 1], idx[i][i + 1] = i + 1;
        }
    }
    for (int len = 3; len <= n; ++len) {
        for (int l = 0; l <= n - len; ++l) {
            int r = l + len - 1;
            ll c = idx[l][r - 1];
            ll a = arr[l], b = arr[r], mid = arr[c];
            dp[l][r] = dp[l][c] + dp[c][r];
            if (a >= mid && b >= mid) {
                ll p = min(a, b);
                dp[l][r] += (len - 2) * (p - mid);
            }
            idx[l][r] = c;
            m[l][r] = m[l][r - 1];
            if (m[l][r] < b) {
                m[l][r] = b, idx[l][r] = r;
            }
        }
    }
    vector<ll> sz(n, 1);
    vector<ll> num(n);
    for (int i = 0; i < n; ++i) {
        num[i] = i;
    }
    for (int i = 0; i < n - 1; ++i) {
        ll t;
        cin >> t;
        t--;
        ll len = sz[t];
        ll l = sz[t + 1];
        cout << dp[num[t]][num[t] + len + l - 1] << '\n';
        sz[t] += l;
        for (int j = t + 1; j < (ll) sz.size() - 1; ++j) {
            sz[j] = sz[j + 1];
            num[j] = num[j + 1];
        }
        sz.pop_back();
        num.pop_back();
    }
}
