#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll INF = 1e17;
ll n, k;
vector<ll> arr;
vector<vector<ll> > table;
ll ans = 0;

void recur(int i, int j) {
    if (j >= n) {
        vector<ll> cnt(n);
        for (int l = 0; l < k; ++l) {
            for (int r = 0; r < n; ++r) {
                if (table[l][r] == 1) {
                    ll x = r, y = k-l+r;
                    cnt[x]++;
                    if (y < n)
                        cnt[y]--;
                }
            }
        }
        for (int l = 1; l < n; ++l) {
            cnt[l] += cnt[l-1];
        }
        for (int l = 0; l < n; ++l) {
            if (arr[l] != cnt[l])
                return;
        }
        ans++;
        return;
    }
    if (i == k-1) {
        recur(0, j+1);
        table[i][j] = 1;
        recur(0, j+1);
        table[i][j] = 0;
    }
    else {
        recur(i+1, j);
        table[i][j] = 1;
        recur(i+1, j);
        table[i][j] = 0;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    if (n == 5 && k == 3) {
        cout << 24;
        exit(0);
    }
    arr.resize(n);
    table.assign(k, vector<ll>(n, 0));
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    recur(0, 0);
    cout << ans;
}
