#include <bits/stdc++.h>
using namespace std;
#define ll int
const ll INF = 1e9;
ll n, s;

struct node {
    ll i, j;
};

vector<vector<ll>> arr;
vector<ll> used;
vector<vector<bool>> visited;

void func (ll i, ll k, ll sum) {
    if (sum > s)
        return;
    if (n == i) {
        if (sum != s) {
            return;
        }
        for (int j = 0; j < n; ++j) {
            if (used[j] == 0)
                return;
        }
        cout << "Yes\n";
        for (int j = 0; j < n; ++j) {
            ll cnt = 0;
            string T = "";
            for (int l = 0; l < arr[j].size(); ++l) {
                if (visited[j][l]) {
                    cnt ++;
                    T += to_string(l+1) + " ";
                }
            }
            cout << cnt << '\n';
            cout << T << '\n';
        }
        exit(0);
    }
    if (k == arr[i].size()-1) {
        if (used[i] == 0) {
            visited[i][k] = 1;
            used[i] ++;
            func (i+1, 0, sum+arr[i][k]);
            visited[i][k] = 0;
            used[i] --;
        }
        else {
            func (i+1, 0, sum);
            visited[i][k] = 1;
            used[i] ++;
            func (i+1, 0, sum+arr[i][k]);
            visited[i][k] = 0;
            used[i] --;
        }
    }
    else {
        func (i, k+1, sum);
        visited[i][k] = 1;
        used[i] ++;
        func (i, k+1, sum+arr[i][k]);
        visited[i][k] = 0;
        used[i] --;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> s;
    vector<vector<ll> > arr(n);
    bool t = true;
    for (int i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        if (k != 1)
            t = false;
        for (int j = 0; j < k; ++j) {
            ll e;
            cin >> e;
            arr[i].push_back(e);

        }
    }
    if (t) {
        used.resize(n);
        visited.resize(n);
        for (int i = 0; i < n; ++i) {
            ll k = arr[i].size();
            cin >> k;
            for (int j = 0; j < k; ++j) {
                visited[i].push_back(0);
            }
        }
        func (0, 0, 0);
        cout << "No\n";
        exit(0);
    }
    vector<vector<vector<node> > > dp(n, vector<vector<node> >(s+1));
    for (int i = 0; i < n; ++i) {
        ll k = arr[i].size();
        for (int j = 0; j < k; ++j) {
            dp[i][0].push_back({-1, -1});
            for (int l = 1; l <= s; ++l) {
                dp[i][l].push_back({-INF, -INF});
            }
        }
    }
    for (int sum = 1; sum <= s; ++sum) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < arr[i].size(); ++j) {
                if (i != 0 || j != 0) {
                    if (j == 0) {
                        dp[i][sum][j] = dp[i-1][sum][dp[i-1][sum].size() - 1];
                        if (i - dp[i][sum][j].i > 1) {
                            dp[i][sum][j] = {-INF, -INF};
                        }
                    } else {
                        dp[i][sum][j] = dp[i][sum][j - 1];
                    }
                    if (i - dp[i][sum][j].i > 1) {
                        dp[i][sum][j] = {-INF, -INF};
                    }
                }
                if (sum - arr[i][j] < 0)
                    continue;
                if (sum == arr[i][j]) {
                    if (i == 0)
                        dp[i][sum][j] = {i, j};
                } else {
                    if (i == 0 && j == 0) {
                    } else {
                        if (j == 0) {
                            if (dp[i-1][sum - arr[i][j]][arr[i - 1].size() - 1].i != -INF && i - dp[i-1][
                                    sum - arr[i][j]][arr[i - 1].size() - 1].i <= 1) {
                                dp[i][sum][j] = {i, j};
                            }
                        } else {
                            if (dp[i][sum - arr[i][j]][j - 1].i != -INF && i - dp[i][sum - arr[i][j]][j - 1].i <= 1) {
                                dp[i][sum][j] = {i, j};
                            }
                        }
                    }
                }
            }
        }
    }
    vector<pair<ll, ll> > answer;
    if (dp[n-1][s][arr[n - 1].size() - 1].i == n - 1) {
        cout << "Yes";
    } else {
        cout << "No";
        exit(0);
    }
    cout << endl;
    ll a = n - 1, b = arr[n - 1].size() - 1;
    while (s > 0) {
        ll a0 = dp[a][s][b].i;
        ll b0 = dp[a][s][b].j;
        answer.push_back({a0, b0});
        s -= arr[a0][b0];
        if (b0 != 0)
            b0--;
        else
            a0--, b0 = arr[a0].size() - 1;
        a = a0, b = b0;
    }
    reverse(answer.begin(), answer.end());
    vector<ll> mem;
    for (int i = 0; i < answer.size(); ++i) {
        if (i != 0 && answer[i].first != answer[i - 1].first) {
            cout << mem.size() << endl;
            for (ll j: mem)
                cout << j + 1 << " ";
            mem.clear();
            cout << endl;
        }
        mem.push_back(answer[i].second);
    }
    if (mem.size() != 0) {
        cout << mem.size() << endl;
        for (int i = 0; i < mem.size(); ++i) {
            cout << mem[i] + 1 << " ";
        }
    }
}
