#include <bits/stdc++.h>
using namespace std;
#define ll int
const ll INF = 1e9;
ll n, s;

struct node {
    ll i, j;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> s;
    vector<vector<ll> > arr(n);
    vector<vector<vector<node> > > dp(s + 1, vector<vector<node> >(n));
    for (int i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            ll e;
            cin >> e;
            arr[i].push_back(e);
            dp[0][i].push_back({-1, -1});
            for (int l = 1; l <= s; ++l) {
                dp[l][i].push_back({-INF, -INF});
            }
        }
    }
    for (int sum = 1; sum <= s; ++sum) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < arr[i].size(); ++j) {
                if (i != 0 || j != 0) {
                    if (j == 0) {
                        dp[sum][i][j] = dp[sum][i - 1][dp[sum][i - 1].size() - 1];
                        if (i - dp[sum][i][j].i > 1) {
                            dp[sum][i][j] = {-INF, -INF};
                        }
                    } else {
                        dp[sum][i][j] = dp[sum][i][j - 1];
                    }
                    if (i - dp[sum][i][j].i > 1) {
                        dp[sum][i][j] = {-INF, -INF};
                    }
                }
                if (sum - arr[i][j] < 0)
                    continue;
                if (sum == arr[i][j]) {
                    if (i == 0)
                        dp[sum][i][j] = {i, j};
                } else {
                    if (i == 0 && j == 0) {
                    } else {
                        if (j == 0) {
                            if (dp[sum - arr[i][j]][i - 1][arr[i - 1].size() - 1].i != -INF && i - dp[sum - arr[i][j]][
                                    i - 1][arr[i - 1].size() - 1].i <= 1) {
                                dp[sum][i][j] = {i, j};
                            }
                        } else {
                            if (dp[sum - arr[i][j]][i][j - 1].i != -INF && i - dp[sum - arr[i][j]][i][j - 1].i <= 1) {
                                dp[sum][i][j] = {i, j};
                            }
                        }
                    }
                }
            }
        }
    }
    vector<pair<ll, ll> > answer;
    if (dp[s][n - 1][arr[n - 1].size() - 1].i == n - 1) {
        cout << "Yes";
    } else {
        cout << "No";
        exit(0);
    }
    cout << endl;
    ll a = n - 1, b = arr[n - 1].size() - 1;
    while (s > 0) {
        ll a0 = dp[s][a][b].i;
        ll b0 = dp[s][a][b].j;
        answer.push_back({a0, b0});
        s -= arr[a0][b0];
        if (a == a0 && b == b0) {
            if (b0 != 0)
                b0--;
            else
                a0--, b0 = arr[a0].size() - 1;
        }
        a = a0, b = b0;
    }
    reverse(answer.begin(), answer.end());
    vector<ll> mem;
    for (int i = 0; i < answer.size(); ++i) {
        if (i != 0 && answer[i].first != answer[i - 1].first) {
            cout << mem.size() << endl;
            for (ll j: mem)
                cout << j + 1 << " ";
            mem.clear();
            cout << endl;
        }
        mem.push_back(answer[i].second);
    }
    if (mem.size() != 0) {
        cout << mem.size() << endl;
        for (int i = 0; i < mem.size(); ++i) {
            cout << mem[i] + 1 << " ";
        }
    }
}
